
AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )
include( 'shared.lua' )

function ENT:SpawnFunction( ply, tr )
	if ( !tr.Hit ) then return end
	local SpawnPos = (tr.HitPos + tr.HitNormal * 16) +Vector( 0, 0, 55 )
	self.Spawn_angles = ply:GetAngles()
	self.Spawn_angles.pitch = 0
	self.Spawn_angles.roll = 0
	self.Spawn_angles.yaw = self.Spawn_angles.yaw + 180
	
	local ent = ents.Create( "monster_apc" )
	ent:SetPos( SpawnPos )
	ent:SetAngles( self.Spawn_angles )
	ent:Spawn()
	ent:Activate()
	
	return ent
end

function ENT:Initialize()
	self:SetCollisionGroup(COLLISION_GROUP_WEAPON)
	self:SetModel( "models/props_junk/watermelon01_chunk02c.mdl" )
	self:SetColor( 255, 255, 255, 0 )
	
	self.apc = ents.Create( "prop_vehicle_apc" )
	self.apc:SetKeyValue( "model", "models/combine_apc.mdl" )
	self.apc:SetKeyValue( "vehiclescript", "scripts/vehicles/apc_npc.txt" )
	self.apc:SetKeyValue( "actionScale", "1" )
	self.apc:SetName( "Combine_apc" .. self:EntIndex() )
	self.apc:SetPos( self:GetPos() )
	self.apc:SetAngles( self:GetAngles() )
	self.apc:Spawn()
	self.apc:Activate()
	
	self.apc_driver = ents.Create( "npc_apcdriver" )
	self.apc_driver:SetKeyValue( "vehicle", "Combine_apc" .. self:EntIndex() )
	self.apc_driver:SetName( "Combine_apc" .. self:EntIndex() .. "_driver" )
	self.apc_driver:SetPos( self:GetPos() )
	self.apc_driver:Spawn()
	self.apc_driver:Activate()
end

function ENT:Think()
	/*
	if !ValidEntity( self.apc ) or !ValidEntity( self.apc_driver ) then self:Remove(); return end
	local enemies = ents.FindByClass( "npc_*" ) 
	table.Add( enemies, ents.FindByClass( "monster_*" ) )
	table.Add( enemies, player.GetAll() )
	if self.targetpath and ValidEntity( self.targetpath ) then Msg( "self.targetpathPOS: " .. tostring(self.targetpath:GetPos()) .. "\n" ) end
	local closestDist = 9999
	for k, v in pairs( enemies ) do
		if v && v:IsValid() && v != self && ( v:IsNPC() or ( v:IsPlayer() and v:Alive() ) ) && v:Health() > 0 then
			//if self.apc_driver:Disposition(v) != 1 then return end
			local enemy_pos = v:OBBCenter()
			local enemy_ang = v:GetAngles()
			local enemy_pos_center = v:GetPos() + enemy_ang:Up() * enemy_pos.z + enemy_ang:Forward() * enemy_pos.x + enemy_ang:Right() * enemy_pos.y
			local trd = {}
			trd.start = self.apc:GetPos()
			trd.endpos = enemy_pos_center
			trd.filter = {self.apc}
			local tr = util.TraceLine(trd)
			if tr.HitNonWorld && tr.Entity && tr.Entity == v then
				local d = v:GetPos():Distance(self.apc:GetPos())
				if d < closestDist then
					closestDist = d
					self.enemy = v
				end
			end
		end
	end
	if self.enemy and ValidEntity( self.enemy ) and self.apc_driver:GetPos():Distance( self.enemy:GetPos() ) > 500 and !self.tgtpath then
		self.tgtpath = true
		self.targetpath = ents.Create( "path_track" )
		self.targetpath:SetPos( self.enemy:GetPos() )
		self.targetpath:SetParent( self.enemy )
		self.targetpath:SetName( "Combine_apc" .. self:EntIndex() .. "_targetpath" )
		self.targetpath:Spawn()
		self.targetpath:Activate()
		//self.apc_driver:Fire( "GotoPathCorner", "Combine_apc" .. self:EntIndex() .. "_targetpath", 0.1 )
	end*/
end

function ENT:Touch(ent)
end


function ENT:OnTakeDamage(dmg)
end

function ENT:OnRemove()
	if ValidEntity( self.apc ) then
		self.apc:Remove()
	end
	if ValidEntity( self.apc_driver ) then
		self.apc_driver:Remove()
	end
end